--- ChangeLog	2005/05/28 08:43:50	1.4
+++ ChangeLog	2005/05/28 11:56:52
@@ -1,3 +1,10 @@
+2005-05-28  Joerg Hoehle <hoehle@users.sourceforge.net>
+
+	* swank-clisp.lisp (describe-symbol-for-emacs): Report :alien-type
+	when the name is known as foreign type.
+	* slime.el (slime-print-apropos): Modify Apropos message 
+	to "Alien / Foreign Type" -- "alien" is specific to CMUCL/SBCL.
+
 2005-05-27  Joerg Hoehle <hoehle@users.sourceforge.net>
 
 	* swank-clisp.lisp (getpid): Use defimplementation.
--- slime.el	2005/05/26 14:33:41	1.2
+++ slime.el	2005/05/28 11:52:49
@@ -5863,10 +5863,10 @@
 		 (:setf "Setf")
 		 (:type "Type")
 		 (:class "Class")
-                 (:alien-type "Alien type")
-                 (:alien-struct "Alien struct")
-                 (:alien-union "Alien type")
-                 (:alien-enum "Alien enum"))
+                 (:alien-type "Alien / Foreign Type")
+                 (:alien-struct "Alien /Foreign struct")
+                 (:alien-union "Alien / Foreign union")
+                 (:alien-enum "Alien / Foreign enum"))
             ;; Properties not listed here will not show up in the buffer
 	    do
 	    (let ((value (plist-get plist prop))
--- swank-clisp.lisp	2005/05/28 08:38:39	1.3
+++ swank-clisp.lisp	2005/05/28 11:41:59
@@ -155,6 +155,17 @@
 	 (doc 'function)))
       (maybe-push :class (when (find-class symbol nil) 
 			   (doc 'type))) ;this should be fixed
+      ;; Let this code work compiled in images without FFI
+      (let ((types (load-time-value
+		    (and (find-package "FFI")
+			 (symbol-value (find-symbol "*C-TYPE-TABLE*" "FFI"))))))
+	;; Use ffi::*c-type-table* so as not to suffer the overhead of
+	;; (ignore-errors (ffi:parse-c-type symbol)) for 99.9% of symbols
+	;; which are not FFI type names.
+	(when (and types (nth-value 1 (gethash symbol types)))
+	  ;; Maybe use (case (head (ffi:deparse-c-type)))
+	  ;; to distinguish struct and union types?
+	  (maybe-push :alien-type :not-documented)))
       result)))
 
 (defimplementation describe-definition (symbol namespace)
